#!/bin/sh
#   begin_generated_IBM_prolog                                          
#                                                                       
#   prolog.pro.ocol.telcosp                                             
#   ******************************************************************  
#   IBM Licensed Source                                                 
#                                                                       
#   OCO Source Materials                                                
#                                                                       
#   Product(s): 5724-O05                                                
#                                                                       
#   Copyright IBM Corp. 2007, 2007                                      
#                                                                       
#   The source code for this program is restricted to the terms         
#   specified by the End User License Agreement (EULA) that             
#   accompanied this product.                                           
#   ******************************************************************  
#                                                                       
#   end_generated_IBM_prolog                                            

# Usage function
usage ( ) {
	echo "Usage:"
	echo "    $0 <db_name> <db_user> <db_password>"
	echo ""
	echo "Example:"
	echo "    $0 xdms system passw0rd"
	echo ""
}

# Check the variables
if [ $# != 3 ]
then
	usage
	exit -1
fi

# Variables
db_name=$1
db_user=$2
db_password=$3

#check and handle globals
if [ "$ORACLE_HOME" != "" ] #is ORACLE_HOME set?
then
ORA_HOME=$ORACLE_HOME #apparently 11g is installed, fix ora_home
fi
if [ "$ORA_HOME" = "" ]
then
echo "ORA_HOME / ORACLE_HOME not set."
exit -1 #and thank Oracle for the regress.
fi

# Create the DB
$ORA_HOME/bin/sqlplus /nolog <<+ENDOFSQL+


connect $db_user/$db_password@$db_name

drop table USERPROFILE;
drop table USERPROFILEACLS;
drop table LCKDUSERPROFILE;
drop table LCKDUSERPROFILEACLS;

create table USERPROFILE (
	"ID" 		varchar(254) not null, 
	"CREATE" 	number(19), 
	"LASTUPDATE" 	number(19), 
	"CREATOR" 	varchar(254), 
	"LASTUPDATOR" 	varchar(254), 
	"DOCUMENT" 	xmltype)
	xmltype column "DOCUMENT" store as binary xml;

ALTER TABLE USERPROFILE 
	ADD CONSTRAINT PK_USRPROF 
	PRIMARY KEY ("ID");

create table USERPROFILEACLS (
	"ID" 		varchar(254) not null, 
	"CREATE" 	number(19), 
	"LASTUPDATE" 	number(19), 
	"CREATOR" 	varchar(254), 
	"LASTUPDATOR" 	varchar(254), 
	"DOCUMENT" 	xmltype)
	xmltype column "DOCUMENT" store as binary xml;

ALTER TABLE USERPROFILEACLS 
	ADD CONSTRAINT PK_USRPROFACL 
	PRIMARY KEY ("ID");

create table LCKDUSERPROFILE (
	"ID" 		varchar(254) not null, 
	"CREATE" 	number(19), 
	"LASTUPDATE" 	number(19), 
	"CREATOR" 	varchar(254), 
	"LASTUPDATOR" 	varchar(254), 
	"DOCUMENT" 	xmltype)
	xmltype column "DOCUMENT" store as binary xml;

ALTER TABLE LCKDUSERPROFILE 
	ADD CONSTRAINT PK_LCKDUSRPROF 
	PRIMARY KEY ("ID");

create table LCKDUSERPROFILEACLS (
	"ID" 		varchar(254) not null, 
	"CREATE" 	number(19), 
	"LASTUPDATE" 	number(19), 
	"CREATOR" 	varchar(254), 
	"LASTUPDATOR" 	varchar(254), 
	"DOCUMENT" 	xmltype)
	xmltype column "DOCUMENT" store as binary xml;

ALTER TABLE LCKDUSERPROFILEACLS 
	ADD CONSTRAINT PK_LCKDUSRPROFACL 
	PRIMARY KEY ("ID");

exit
ENDOFSQL


