import sys
import string
import os.path

#---------------------------------------------------------------------
#  def: print IBM Copyright
#---------------------------------------------------------------------
def printCopyright():
   print """
      ***************************************************************
      Licensed Materials - Property of IBM
      5724-O05
      (c) Copyright IBM Corp. 2006, 2008 All Rights Reserved.
      Trademark of International Business Machines
      ***************************************************************
   
   """
#endDef printCopyright

#-----------------------------------------------------------------
# Validation Functions
#-----------------------------------------------------------------
def validate():
   if ( dest == "" ):
      sys.stderr.write('You must specify a -dir argument\n');
      sys.exit(2)
   
   if ( apps == "" ):
      sys.stderr.write('You must specify a -app argument with a comma separated list of Application display names\n');
      sys.exit(3)
#endDef validate

#-----------------------------------------------------------------
# Helper Functions
#-----------------------------------------------------------------

# Takes in a list from a WSAdmin object and creates a Jython list out of it
def toList(inStr):
   outList=[]
   if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
      tmpList = inStr[1:-1].split(" ")
   else:
      tmpList = inStr.split("\n")  #splits for Windows or Linux
      for item in tmpList:
         item = item.rstrip();        #removes any Windows "\r"
         if (len(item)>0):
            outList.append(item)
   return outList
#endDef

def hyphenate(string):
   return string.replace(" ","-")
#endDef

#-----------------------------------------------------------------
# Methods
#-----------------------------------------------------------------
def findAndExportXdmsApps(installed, xdms):
   
   # Will hold the data for the installed apps
   # Format for each entry [APP_NAME, DEPLOY_SCOPE_TYPE, DEPLOY_SCOPE_ID]
   # Example [[SharedListXdms_EAR, ServerCluster, <clusterID>], 
   #		[Presence Rules XDMS, Server, <serverid>]]
   installedApps = []
   print ">>entry findAndExportXdmsApps("+str(installed)+","+str(xdms)+")"
   for app in installed:
      for xdmsApp in xdms:
         if( str(app) == str(xdmsApp) ):
            AdminApp.export(app, dest+"/"+"_"+hyphenate(app)+".ear")
            sys.stdout.write('App found: '+app+'\n')
            
            # Gather application information
            scope = ""
            scopeId = ""
            
            # Determine deployment scope
            # Prefer the SIPNotify jar's scope
            
            # format of moduleList below will look like:
            
            # ... text ...
            #
            # Module: SIPNotify
            # URI: SIPNotify.jar,META-INF/ejb-jar.xml
            # Server: WebSphere:cell=bboxCell01,cluster=PresenceRulesCluster
            #
            # Module: PresenceRulesXdms
            # URI: PresenceRulesXdms.war,WEB-INF/web.xml
            # Server: WebSphere:cell=bboxCell01,cluster=PresenceRulesCluster           
	    
	    moduleList = toList( AdminApp.view(str(app), ['-MapModulesToServers']) )
            print "\nModule List: \n"+str(moduleList)
	    scopeType = ""
	    #============ start - defect 19577 ===========            
	    for line in moduleList:
	    	#print "Current line is" + str(line) +"\n"
            	if (line.find(',cluster=') > 0):
        		scopeType = 'ServerCluster'
	       		print "scopeType is ServerCluster"
	       		index = line.find(',cluster=')
               		idQuery = '/ServerCluster:'+line[index+9:len(line)]
               		scopeId = AdminConfig.getid(idQuery)
               		break
               	elif (line.find(',node=') > 0):
               		print "scopeType is Server"
               		nodeIndex = line.find(',node=')
	       		serverIndex = line.find(',server=')
	       		#print "nodeindex is: "+ str(nodeIndex)
	       		#print "serverIndex is: "+ str(serverIndex )
               		scopeType = 'Server'
               		idQuery = '/Node:'+line[nodeIndex+6:serverIndex]\
               			+'/Server:'+line[serverIndex+8:len(line)]
               		#print "idQuery is: "+ str(idQuery )
               		scopeId = AdminConfig.getid(idQuery)
               		break
               	#end if
             #end for
	    
	    
            #module = "" # current module name from "Module: name" line
            #for line in moduleList:
            #   if( str(line).startswith('Module: ') ):
            #      module = line[8:len(line)];
            #   if( str(line).startswith('Server: ') ):
            #   	  scope = line[8:len(line)]
            #   	  if( module == 'SIPNotify' ):
            #   	     break
            #   	  #endIf
            # Determine if this is a cluster or server install,
            # Get the WAS scope ID 
	    #print "Scope is: "+scope 	  
            #index = scope.find(',cluster=')
	    #print "Cluster index is: "+str(index) 
            #if ( index > 0 ):
            #   scopeType = 'ServerCluster'
	    #   print "this is ServerCluster"
            #   idQuery = '/ServerCluster:'+scope[index+9:len(scope)]
            #   scopeId = AdminConfig.getid(idQuery)
            #else:
	    #   print "this is Node/Server"
            #   nodeIndex = scope.find(',node=')
	    #   serverIndex = scope.find(',server=')
	    #   print "nodeindex is: "+ str(nodeIndex)
	    #   print "serverIndex is: "+ str(serverIndex )
            #   scopeType = 'Server'
            #   idQuery = '/Node:'+scope[nodeIndex+6:serverIndex]\
            #             +'/Server:'+scope[serverIndex+8:len(scope)]
            #   print "idQuery is: "+ str(idQuery )
            #   scopeId = AdminConfig.getid(idQuery)
            #============ end - defect 19577 ===========
            
            installedApps.append([app, scopeType, scopeId])
            break
         #endIf
      #endFor
   #endFor
   
   return installedApps
     
#endDef

#-----------------------------------------------------------------
# Main
#-----------------------------------------------------------------

# Member fields
dest = ""
apps = ""

# IBM Legal Statement
printCopyright()

# Init loop params
count = 0
arglen = len(sys.argv)
while (count < arglen):
   paramflag = sys.argv[count]
   count = count+1 
   if (cmp(paramflag, "-dir") == 0):
      param = sys.argv[count]
      dest = param
   elif (cmp(paramflag, "-apps") == 0):
      param = sys.argv[count]
      apps = param
   #endIf 
   count = count+1
#endWhile 

# Validate args
validate()

# List of all IBM XDMS enabler display names
xdmsAppList = []

#appList.replace('\"',''); 
appList = apps.split(",")
for item in appList:
   if (len(item)>0):
      xdmsAppList.append(item)

# Get a list of installed Apps
installedAppList = toList( AdminApp.list() )

# find and export EARs
# print data to be read by a parser
print findAndExportXdmsApps( installedAppList, xdmsAppList )
sys.exit(0)
