import java.lang.System as system
import sys
import os
from java.util import Locale, ResourceBundle, MissingResourceException


#---------------------------------------------------------------------
#  def: print IBM Copyright
#---------------------------------------------------------------------
def printCopyright():
	sys.stdout.write( '***************************************************************\n\n\
	Licensed Materials - Property of IBM\n\
	5724-O05\n\
	(c) Copyright IBM Corp. 2008 All Rights Reserved.\n\
	* Trademark of International Business Machines\n')
	sys.stdout.write('***************************************************************\n\n')
#endDef printCopyright

#-----------------------------
# usage output
#-----------------------------
def usage():
   print """
      Syntax: wsadmin -f TcapGetProfileType.py -profileHome <path_to_profile_home>
   """
   sys.exit(2)

#-------------------------------------------------------------------
# Method:   getServerType
# Description: Return the Profile type: DMGR/NODE/STANDALONE  
# Parameters:  	
#		wasProfileHome - was profile directory
#	
# Returns:	DMGR/NODE/STANDALONE - as per the type of profile
#--------------------------------------------------------------------   	
def getServerType(wasProfileHome):
	cellType = AdminConfig.showAttribute(AdminConfig.list("Cell"),"cellType")
	if (cellType == "DISTRIBUTED"):
		checkFileUnix = wasProfileHome + "/bin/startManager.sh"
		#print "unix: " + checkFileUnix
		checkFileWin = wasProfileHome + "/bin/startManager.bat"
		#print "win: " + checkFileWin
		if ( os.path.isfile(checkFileUnix) or os.path.isfile(checkFileWin) ): 
			return "DMGR"
		else:
			return "NODE"
			  
	elif (cellType == "STANDALONE") :
		return "STANDALONE"	
	else:
		return "UNKNOWN"
	#end if
#endDef getServerType

###################################
#main
###################################
locale = java.util.Locale.getDefault()
count = 0
profileHome=""
arglen = len(sys.argv)
sys.stderr.write('')
while (count < arglen):
        paramflag = sys.argv[count]
        count = count+1 
	if (cmp(paramflag, "-profileHome") == 0):
		if (arglen > count):
			param = sys.argv[count]
                	profileHome = param
        #endIf 

        count = count+1
#endWhile 

if(profileHome == ""):
	aMsg  = "PROFILE_HOME_MISSING";
	sys.stderr.write(aMsg)
	usage()
#end if

print "[["+getServerType(profileHome)+"]]"
sys.exit(0)