import sys
import string
import re

#-----------------------------------------------------------------
# Functions
#-----------------------------------------------------------------

#---------------------------------------------------------------------
#  def: print IBM Copyright
#---------------------------------------------------------------------
def printCopyright():
   print """
      ***************************************************************
      Licensed Materials - Property of IBM
      5724-O05
      (c) Copyright IBM Corp. 2006, 2008 All Rights Reserved.
      Trademark of International Business Machines
      ***************************************************************
   
   """
#endDef printCopyright

def buildContainmentPath(scopeId):
   outputStr = ""
   stIndex = scopeId.find("(") + 1
   endIndex = scopeId.find("|")
   scopeLst = scopeId[stIndex:endIndex].split("/")
   scopeListLen = len(scopeLst)
   for i in range(0, scopeListLen, 2):
      scopeType = scopeLst[i]
      scopeValue = scopeLst[i+1]
      if(scopeType == "cells"):
         outputStr = "/Cell:%s/" % scopeValue
      elif(scopeType == "clusters"):
         outputStr += "ServerCluster:%s/" % scopeValue
      elif(scopeType == "nodes"):
         outputStr += "Node:%s/" % scopeValue
      elif(scopeType == "servers"):
         outputStr += "Server:%s/" % scopeValue
   return outputStr

def getScopes(scopeType, scopes = []):        
    if scopeType == "Cell":
       getScopes("ServerCluster", scopes)
       getScopes("Node", scopes)
       return scopes
    elif scopeType == "Node":
       scopeType = "Server"

    temp = []; 
    temp = AdminConfig.list(scopeType).split("\n")
    for scope in temp[:]:
        if scope != "":
    	    #objName = AdminConfig.getObjectName(scope)
    	    #contPath = buildContainmentPath(scope)
            
            # Check the validity of the scope for installation
            valid = 1
            type = AdminConfig.showAttribute(scope, 'serverType')
	    # Ensure this isn't a DM or Node Agent
            if(type == "NODE_AGENT" or type == "DEPLOYMENT_MANAGER"):
            	valid = 0
            
    	    #Ensure this isn't a cluster member
    	    # Reference: http://is.gd/zGz
    	    elif(scopeType == "Server" and type == "APPLICATION_SERVER"):
    	    	#type = AdminConfig.showAttribute("'"+contPath+"'", 'serverType')
    	    	clusterName = AdminConfig.showAttribute(scope, 'clusterName')
    	    	if(clusterName is not None):
    	    	   valid = 0
	    	    	
    	    # Add the scope to the list if it is valid
    	    if valid:
    	        scopes.append([scopeType, scope])
    return scopes
#def
    
##### MAIN
count = 0
scopeType = "Cell"
arglen = len(sys.argv)

while (count < arglen):
        paramflag = sys.argv[count]
        count = count+1 

        if (cmp(paramflag, "-scopeType") == 0):
                param = sys.argv[count]
                scopeType = param
        #endIf 

        count = count+1
#endWhile 

# IBM Legal Statement
printCopyright()

print getScopes(scopeType);
sys.exit(0)
